/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_NEXUS_FORMAT_H_
#define _GB2_NEXUS_FORMAT_H_

#include <core_api/DocumentFormats.h>
#include <core_api/DocumentModel.h>

#include <core_api/IOAdapter.h>
#include <core_api/Task.h>

#include <cassert>

namespace GB2 
{

class IOAdapter;

class GB2_COREAPI_EXPORT NEXUSFormat : public DocumentFormat 
{
	Q_OBJECT

public:
    NEXUSFormat(QObject *p);

    virtual DocumentFormatId getFormatId() const { return BaseDocumentFormats::NEXUS; }
    virtual const QString& getFormatName() const { return formatName; }

    virtual bool checkRawData(const QByteArray &rawData) const;

    virtual Document* loadDocument(IOAdapter *io, TaskStateInfo &ti, const QVariantMap &fs, DocumentLoadMode mode = DocumentLoadMode_Whole);
    virtual void storeDocument(Document *d, TaskStateInfo &ts, IOAdapter *io);

private:
    QList<GObject*> loadObjects(IOAdapter *io, TaskStateInfo &ti);
    void storeObjects(QList<GObject*> objects, IOAdapter *io, TaskStateInfo &ti);

private:
    QString formatName;
};

} // namespace GB2

#endif	// #ifndef _GB2_NEXUS_FORMAT_H_
