/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#include <core_api/AppContext.h>
#include <distributed_computing/RemoteMachineMonitor.h>

#include "CloudSupport.h"
#include "CloudSupportPlugin.h"
#include "CloudSupportProtocolUI.h"

namespace GB2 {


#define EC2_URL     "http://184.73.180.209:80/rservice/engine"
#define EC2_USER    "ugene"
#define EC2_PASS    "rulezzz"

extern "C" Q_DECL_EXPORT GB2::Plugin* GB2_PLUGIN_INIT_FUNC()
{
    CloudSupportPlugin* plug = new CloudSupportPlugin();
    return plug;
}

const QString CloudSupport::CLOUD_SUPPORT_PROTOCOL_ID = "Cloud support transport protocol";

CloudSupportPlugin::CloudSupportPlugin():
    Plugin(tr("Cloud Support"),
        tr("UGENE On The Cloud transport protocol and task execution")),
    protocolUI((NULL == AppContext::getMainWindow())? NULL:(new CloudSupportProtocolUI())),
    protocolInfo( CloudSupport::CLOUD_SUPPORT_PROTOCOL_ID , &remoteTaskServer,  protocolUI.get(),
                  &remoteMachineFactory, &remoteMachineScanner )
{
    AppContext::getProtocolInfoRegistry()->registerProtocolInfo(&protocolInfo);

    CloudRemoteMachineSettings* settings = new CloudRemoteMachineSettings(EC2_URL, EC2_USER, EC2_PASS);
    AppContext::getRemoteMachineMonitor()->addMachine(settings, false);
}

CloudSupportPlugin::~CloudSupportPlugin()
{

}

} // namespace GB2
