/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _CLOUD_SUPPORT_PLUGIN_H_
#define _CLOUD_SUPPORT_PLUGIN_H_

#include <memory>
#include <core_api/PluginModel.h>
#include <distributed_computing/ProtocolInfo.h>

#include "CloudRemoteMachine.h"
#include "CloudRemoteTaskServer.h"
#include "CloudMachineScanner.h"

namespace GB2 {

class CloudSupportProtocolUI;

class CloudSupportPlugin : public Plugin {
    Q_OBJECT

public:
    CloudSupportPlugin();
    virtual ~CloudSupportPlugin();

private:
    std::auto_ptr<CloudSupportProtocolUI> protocolUI;
    CloudRemoteMachineFactory remoteMachineFactory;
    CloudRemoteTaskServer remoteTaskServer;
    CloudMachineScanner remoteMachineScanner;
    ProtocolInfo protocolInfo;
};

} // namespace GB2

#endif // _CLOUD_SUPPORT_PLUGIN_H_
