/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#include <core_api/AppContext.h>

#include "CloudSupport.h"
#include "CloudRemoteMachine.h"
#include "CloudSupportProtocolUI.h"

static const int PORT_MAX = 0x7fff;

namespace GB2 {



CloudSupportProtocolUI::CloudSupportProtocolUI()
{
    setupUi(this);
}

CloudSupportProtocolUI::~CloudSupportProtocolUI()
{

}

RemoteMachineSettings * CloudSupportProtocolUI::createMachine() const
{
    if( !validate().isEmpty() )
    {
        return NULL;
    }
    return new CloudRemoteMachineSettings(urlLineEdit->text(), userNameEdit->text(), passwdEdit->text());
}

void CloudSupportProtocolUI::initializeWidget(const RemoteMachineSettings *settings)
{
    const CloudRemoteMachineSettings *castedSettings =
            dynamic_cast<const CloudRemoteMachineSettings *>(settings);
    if(NULL != castedSettings)
    {
        urlLineEdit->setText(castedSettings->getUrl());
        userNameEdit->setText(castedSettings->getUserName());
        passwdEdit->setText(castedSettings->getPasswd());
    }
}

QString CloudSupportProtocolUI::validate() const {
    if( urlLineEdit->text().isEmpty() ) {
        return tr( "Url is empty!" );
    }
    if( userNameEdit->text().isEmpty()) {
        return tr( "User name is not valid!" );
    }
    if( passwdEdit->text().isEmpty())  {
        return tr( "Password is empty!" );
    }

    
    return QString();
}

void CloudSupportProtocolUI::clearWidget() {


}

} // namespace GB2
