/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_EXTERNAL_TOOL_SUPPORT_SETTINGS_CONTROLLER_H
#define _GB2_EXTERNAL_TOOL_SUPPORT_SETTINGS_CONTROLLER_H

#include <core_api/AppSettingsGUI.h>
#include <core_api/ExternalToolRegistry.h>
#include <ui/ui_ETSSettingsWidget.h>
namespace GB2
{
#define ExternalToolSupportSettingsPageId QString("ets")

class ExternalToolSupportSettingsPageController : public AppSettingsGUIPageController {
    Q_OBJECT
public:
    ExternalToolSupportSettingsPageController(QObject* p = NULL);

    AppSettingsGUIPageState* getSavedState();
    void saveState(AppSettingsGUIPageState* s);
    AppSettingsGUIPageWidget* createWidget(AppSettingsGUIPageState* state);

};

class ExternalToolSupportSettingsPageState : public AppSettingsGUIPageState {
    Q_OBJECT
public:
    QList<ExternalTool*>    externalTools;
    QString                 temporaryDirectory;

};

class ExternalToolSupportSettingsPageWidget: public AppSettingsGUIPageWidget, public Ui_ETSSettingsWidget {
    Q_OBJECT
public:
    ExternalToolSupportSettingsPageWidget(ExternalToolSupportSettingsPageController* ctrl);

    virtual void setState(AppSettingsGUIPageState* state);

    virtual AppSettingsGUIPageState* getState(QString& err) const;
private slots:
    void sl_onBrowseTemporyDir();
private:
    QWidget* createEditor(QWidget *parent, const QString& path) const;
};

class PathLineEdit : public QLineEdit {
    Q_OBJECT
public:
    PathLineEdit(const QString& filter, const QString& type, bool multi, QWidget *parent)
        : QLineEdit(parent), FileFilter(filter), type(type), multi(multi) {}

private slots:
    void sl_onBrowse();
    void sl_clear();

private:
    QString FileFilter;
    QString type;
    QString path;
    bool    multi;

};
}//namespace

#endif // _GB2_EXTERNAL_TOOL_SUPPORT_SETTINGS_CONTROLLER_H
