/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_MAFFT_WORKER_H_
#define _GB2_MAFFT_WORKER_H_

#include <workflow_library/LocalDomain.h>
#include <workflow_support/WorkflowUtils.h>
#include "MAFFTSupportTask.h"

namespace GB2 {

namespace LocalWorkflow {

class MAFFTPrompter : public PrompterBase<MAFFTPrompter> {
    Q_OBJECT
public:
    MAFFTPrompter(Actor* p = 0);
protected:
    QString composeRichDoc();
private slots:
    void sl_pathChanged();
};

class MAFFTWorker : public BaseWorker {
    Q_OBJECT
public:
    MAFFTWorker(Actor* a);
    
    virtual void init();
    virtual bool isReady();
    virtual Task* tick();
    virtual bool isDone();
    virtual void cleanup();
    
private slots:
    void sl_taskFinished();

protected:
    CommunicationChannel *input, *output;
    QString resultName,transId;
    MAFFTSupportTaskSettings cfg;
    
}; 

class MAFFTWorkerFactory : public DomainFactory {
public:
    static const QString ACTOR_ID;
    static void init();
    MAFFTWorkerFactory() : DomainFactory(ACTOR_ID) {}
    virtual Worker* createWorker(Actor* a) {return new MAFFTWorker(a);}
};

}//Workflow namespace
}//GB2 namespace

#endif
