/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#include "ExternalToolSupportAction.h"

#include <core_api/AppContext.h>

namespace GB2 {

ExternalToolSupprotAction::ExternalToolSupprotAction(QObject* p, GObjectView* v, const QString& _text, int order, const QString& _toolName)
    : GObjectViewAction(p,v,_text,order), toolName(_toolName)
{
    QFont myFont;
    if(AppContext::getExternalToolRegistry()->getByName(toolName)->getPath().isEmpty() ||
       (AppContext::getExternalToolRegistry()->getTemporaryDir().isEmpty())){
        myFont.setItalic(true);
        setFont(myFont);
        setText(text()+"...");
        setIcon(AppContext::getExternalToolRegistry()->getByName(toolName)->getGrayIcon());
    }else{
        myFont.setItalic(false);
        setFont(myFont);
        if(text().endsWith("...")){
            setText(text().remove(text().length()-3,3));
        }else{
            setText(text());
        }
        setIcon(AppContext::getExternalToolRegistry()->getByName(toolName)->getIcon());
    }
    ExternalTool* exTool=AppContext::getExternalToolRegistry()->getByName(toolName);
    connect(exTool, SIGNAL(si_pathChanged()), SLOT(sl_pathChanged()));
    connect(AppContext::getExternalToolRegistry(), SIGNAL(si_temporyDirChanged()), SLOT(sl_pathChanged()));
}

ExternalToolSupprotAction::ExternalToolSupprotAction(const QString& _text, QObject* p, const QString& _toolName)
    : GObjectViewAction(p, NULL, _text), toolName(_toolName)
{
    QFont myFont;
    if(AppContext::getExternalToolRegistry()->getByName(toolName)->getPath().isEmpty() ||
       (AppContext::getExternalToolRegistry()->getTemporaryDir().isEmpty())){
        myFont.setItalic(true);
        setFont(myFont);
        setText(text()+"...");
        setIcon(AppContext::getExternalToolRegistry()->getByName(toolName)->getGrayIcon());
    }else{
        myFont.setItalic(false);
        setFont(myFont);
        if(text().endsWith("...")){
            setText(text().remove(text().length()-3,3));
        }else{
            setText(text());
        }
        setIcon(AppContext::getExternalToolRegistry()->getByName(toolName)->getIcon());
    }
    ExternalTool* exTool=AppContext::getExternalToolRegistry()->getByName(toolName);
    connect(exTool, SIGNAL(si_pathChanged()), SLOT(sl_pathChanged()));
    connect(AppContext::getExternalToolRegistry(), SIGNAL(si_temporyDirChanged()), SLOT(sl_pathChanged()));
}

void ExternalToolSupprotAction::sl_pathChanged() {

    QFont my;
    if(AppContext::getExternalToolRegistry()->getByName(toolName)->getPath().isEmpty() ||
       (AppContext::getExternalToolRegistry()->getTemporaryDir().isEmpty())){
        my.setItalic(true);
        setFont(my);
        if(!text().endsWith("...")){
            setText(text()+"...");
        }
        setIcon(AppContext::getExternalToolRegistry()->getByName(toolName)->getGrayIcon());
    }else{
        my.setItalic(false);
        setFont(my);
        if(text().endsWith("...")){
            setText(text().remove(text().length()-3,3));
        }
        setIcon(AppContext::getExternalToolRegistry()->getByName(toolName)->getIcon());
    }

}

}//namespace
