/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_CREATE_SCRIPT_WORKER_DIALOG_H_
#define _GB2_CREATE_SCRIPT_WORKER_DIALOG_H_

#include "ui/ui_CreateScriptBlockDialog.h"
#include <workflow/WorkflowModel.h>
#include <workflow/WorkflowEnv.h>
#include <workflow_support/DelegateEditors.h>
#include <workflow_library/BioDatatypes.h>
#include <workflow_support/CoreDataTypes.h>

#include <core_api/AppContext.h>
#include <core_api/IOAdapter.h>
#include <core_api/Settings.h>

#include <QtXml/qdom.h>

namespace GB2 {
using namespace Workflow;

class CreateScriptElementDialog : public QDialog,  public Ui_CreateScriptBlockDialog {
    Q_OBJECT
public:
    CreateScriptElementDialog(QWidget* p = NULL);
    QList<DataTypePtr > getInput() const;
    QList<DataTypePtr > getOutput() const;
    QList<Attribute*> getAttributes() const;
    const QString getName() const;
    const QString getDescription() const;

private slots:
    void sl_addInputClicked();
    void sl_addOutputClicked();
    void sl_okClicked();
    void sl_cancelClicked();
    void sl_addAttribute();
    void sl_deleteInputClicked();
    void sl_deleteOutputClicked();
    void sl_deleteAttributeClicked();

private:
    QDomDocument saveXml();
    void saveParams();

    QList<DataTypePtr > input;
    QList<DataTypePtr > output;
    QList<Attribute*> attrs;
    QString name;
    QString description;
};

} //namespace

#endif
