/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#ifndef _GB2_WORFLOW_ON_THE_CLOUD_TASK_H_
#define _GB2_WORFLOW_ON_THE_CLOUD_TASK_H_

#include <distributed_computing/LocalTask.h>
#include <core_api/VirtualFileSystem.h>
#include <distributed_computing/RemoteMachine.h>
#include <distributed_computing/RemoteTask.h>

#include <workflow/Schema.h>
#include <workflow_support/WorkflowRunTask.h>

namespace GB2 {

using namespace Workflow;

class WorkflowOnTheCloudRunTask : public Task {
    Q_OBJECT
public:
    WorkflowOnTheCloudRunTask( RemoteMachineSettings * m, const Schema & sc, const QList<Iteration> & its );
    ~WorkflowOnTheCloudRunTask();

    virtual void prepare();
    virtual void run();
    virtual ReportResult report();

private:
    void preprocessSchema();
    void setRemoteMachineError(const QString& error);

private slots:
    void sl_remoteTaskTimerUpdate();

private:
    RemoteMachineSettings *machineSettings;
    RemoteMachine *         machine;
    Schema                  schema;
    QList<Iteration>        iterations;
    qint64                  taskId;
    QEventLoop*             eventLoop;
    QStringList             outputUrls;

}; // WorkflowOnTheCloudRunTask

} // GB2

#endif // _GB2_WORFLOW_ON_THE_CLOUD_TASK_H_
