/*****************************************************************
* Unipro UGENE - Integrated Bioinformatics Suite
* Copyright (C) 2008,2009 Unipro, Russia (http://ugene.unipro.ru)
* All Rights Reserved
* 
*     This source code is distributed under the terms of the
*     GNU General Public License. See the files COPYING and LICENSE
*     for details.
*****************************************************************/

#include "TaskLocalStorage.h"
#include <assert.h>

class KalignContext *getKalignContext() {
    return GB2::TaskLocalData::current();
}
int getKalignWorkerID() {
    return GB2::TaskLocalData::currentWorkerID();
}

namespace GB2 {

QThreadStorage<KalignContextTLSRef*> TaskLocalData::tls;

class KalignContext* TaskLocalData::current(){
    KalignContextTLSRef* ref = tls.localData();
    if (ref!=NULL) {
        assert(ref->ctx!=NULL);
        return ref->ctx;
    }
    assert(0);
    return NULL;
}

unsigned TaskLocalData::currentWorkerID() {
    KalignContextTLSRef* ref = tls.localData();
    if (ref!=NULL) {
        return ref->workerID;
    }
    assert(0);
    return -1;

}

void TaskLocalData::bindToKalignTLSContext(KalignContext *ctx, int workerID) {
    assert(ctx!=NULL);
    assert(!tls.hasLocalData());
    tls.setLocalData(new KalignContextTLSRef(ctx, workerID));
}

void TaskLocalData::detachKalignTLSContext() {
    KalignContextTLSRef* ref = tls.localData();
    assert(ref!=NULL && ref->ctx!=NULL);
    ref->ctx = NULL;
    tls.setLocalData(NULL);
}


}//namespace

